#!/usr/bin/python
# _*_ coding: utf-8 _*_
#
# fichier radiolite.py
# permet d'écouter les stations de la BBC en ligne de commande avec VLC

# import
import os
import subprocess

# test si vlc-nox est installé
# /usr/bin/cvlc
if not os.path.exists("/usr/bin/cvlc"):
	print "l'éxécutable \"cvlc\" n'a pas été trouvé, installez le paquet \"vlc-nox\" ou \"VLC\""
else:
	# variable
	myList = []

	# création d'une classe
	class Radio(object):
		def __init__(self,name,url):
			self._name = name
			self._url = url
			# ajout l'objet ma liste
			myList.append(self)

		def getName(self):
			return self._name

		def getUrl(self):
			return self._url

		# méthode écouter
		def startLearn(self):
			print self.getName()
			# command = "cvlc " + self.getUrl()
			# os.system(command)
			# print command
			p=subprocess.Popen(['cvlc', self.getUrl(), '>', '/dev/null', '2>&1'], stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr= subprocess.PIPE)
			# print p.pid
			endSubProcess = 0
			while not endSubProcess:
				base = raw_input('Appuyer sur une touche pour arrêter la station\n')
				if base == "":
					print "Arrêt de la station\n"
					# terminer le processus p
					p.terminate()
					endSubProcess = 1
					displayRadio()

	# instanciation des différentes radios
	radio1 = Radio("BBC 1","http://www.bbc.co.uk/radio/listen/live/r1.asx")
	radio2 = Radio('BBC 2','http://www.bbc.co.uk/radio/listen/live/r2.asx')
	radio3 = Radio('BBC 3','http://www.bbc.co.uk/radio/listen/live/r3.asx')
	radio4 = Radio('BBC 4','http://www.bbc.co.uk/radio/listen/live/r4.asx')
	radio5 = Radio('BBC 5','http://www.bbc.co.uk/radio/listen/live/r5.asx')
	radio6 = Radio('BBC 6','http://www.bbc.co.uk/radio/listen/live/r6.asx')
	radio7 = Radio('BBC 7','http://www.bbc.co.uk/radio/listen/live/r7.asx')

	# affichage de la liste de radios
	def displayRadio():
		j = 0
		print "********************************"
		print "*  Liste des radios de la BBC  *"
		print "********************************"
		for i in myList:
			j += 1
			print "%d - %s" % (j,i.getName())

	# appel de la fonction displayRadio
	displayRadio()

	# select case
	end = 0
	while not end:
		base = raw_input('Choisissez votre radio (q pour quitter) :')
		#i = int(base) # exemple de transtypage en python
		if base == "1":
			radio1.startLearn()
		elif base == "2":
			radio2.startLearn()
		elif base == "3":
			radio3.startLearn()
		elif base == "4":
			radio4.startLearn()
		elif base == "5":
			radio5.startLearn()
		elif base == "6":
			radio6.startLearn()
		elif base == "7":
			radio7.startLearn()
		elif base =="q":
			print "Merci d'utiliser RadioLite"
			end = 1
		elif base =="":
			displayRadio()

# notre configuration de vim pour ce fichier
# vim: ts=4 sw=4 expandtab
